Subject: Re: [PATCH net-next 5/5] rocker: remove support for legacy VLAN ndo ops

From: Toshiaki Makita <[email-masked]>
Date: Thu, 04 Jun 2015 23:35:22 +0900

On 15/06/04 (木) 15:05, Scott Feldman wrote:
> On Thu, 4 Jun 2015, Toshiaki Makita wrote:
>
>> Bridge's vlan_filtering is handled in master->op->foo(), not in
>> port->op->foo().
>> Can't we introduce another switchdev handler that performs MASTER
>> operation instead of calling SELF operation?
>>
>> br_afspec()
>> nbp_vlan_add()
>>  netdev_switch_port_vlan_add()
>>   rocker->ndo_switch_port_vlan_add() <- only used for MASTER operation
>>
>> I'm wondering why SELF operation (rocker->ndo_bridge_setlink()) does
>> what should be done in MASTER operation.
>
> Something like this:

This looks very close to what I'm suggesting, although I'm not sure if
we need switchdev_port_obj_add() to be exclusive with vlan_vid_add().
For rocker, keeping NETIF_F_HW_VLAN_[CTAG/STAG]_FILTER dropped makes
vlan_vid_add() essentially noop.

Toshiaki Makita